$storage:2
$floatcalls
	PROGRAM EGADEMO
c	****************************************************************
c	* This program demonstrates the use of each of the functions   *
c	* contained in the Enhanced Graphics Toolkit.  MS Fortran 4.01 *
c	* was used for this example program.			       *
c	*							       *
c	*   Written By:  Ed Connell	Revised: 4/22/88	       *
c	*   Connell Scientific Graphics				       *
c	*   PO Box 1765						       *
c	*   Woodinville, WA  98072-1765				       *
c	*   (206) 485-2828					       *
c	*							       *
c	*   Copyright (C) Connell Scientific Graphics  1986, 1987, 1988*
c	*   All Rights Reserved.				       *
c	****************************************************************
	common /idat/ buff
	common /idat2/ hbuff,pt,sintab
c------ define local variables
	integer*2 titfram(14),cmap(3,5),c1,c2,row,start
	integer*2 imap(3,16),circ(2,36),pt(1000),circ2(2,36)
	integer*2 buff(28800),bcols(3,7),hbuff(600),circh(2,36)
	integer*2 idb(2,5),ipb(2,5),ipage,et(4),imcols(3,10)
	integer*2 sfont(2),lfont(2),hset(11)
	character*77 str,title(5)*40,atm(12)*5,ans*1,cv*40
	character*1 fpat1(64),fpat2(64),fpat3(64),fpat4(64),solid(64)
	character*1 style(64),fstyle(64)
	logical*2 new,pzero,mem256,flip,exi,pcat
	real cube(3,15),r1(3),xyz(3,3,3),sintab(2,36),sc,rate
	data hset/1,1,0,300,0,0,0,0,0,0,0/
	data titfram/194,59,194,290,0,349,639,349,445,290,445,
     +               59,639,0/
	data cmap/0,0,1, 0,1,0, 0,1,1, 1,0,0, 1,0,1/
	data imcols/0,0,0,  1,1,1,  2,2,2,  1,1,2,
     +              0,0,2,  0,0,3,  2,0,2,  2,0,0,
     +              3,0,0,  3,3,0/

	data cube/ .5,-.5,-.5, -.5,-.5,-.5, -.5,-.5,.5, .5,-.5,.5,
     +    .5,.5,.5, -.5,.5,.5, -.5,-.5,.5, -.5,.5,.5, -.5,.5,-.5,
     +   -.5,-.5,-.5, -.5,.5,-.5, .5,.5,-.5, .5,-.5,-.5, .5,.5,-.5,
     +   .5,.5,.5/

	data atm/'C1','H1','C2','H2','C3','H3','C4','H4','C5',
     +       'H5','C6','H6'/
	data bcols/8,1,9,  8,2,10, 8,3,11, 8,4,12,
     +             8,5,13, 8,6,14, 8,7,15/
	data idb/10,10,-10,5,15,5,10,-5,-5,10/
	data title/'   Connell Scientific Graphics   ',
     +		   '            Presents             ',
     +		   '  The Enhanced Graphics Toolkit  ',
     +		   '              For                ',
     +		   '  The Enhanced Graphics Display  '/
c	****************************************************************
c	Define fill patterns

	data solid / 64*0 /

	data fpat1 /  1, 7, 1, 7, 1, 7, 1, 7,
     +		      7, 1, 7, 1, 7, 1, 7, 1, 
     +		      1, 7, 1, 7, 1, 7, 1, 7,
     +		      7, 1, 7, 1, 7, 1, 7, 1,
     +		      1, 7, 1, 7, 1, 7, 1, 7,
     +		      7, 1, 7, 1, 7, 1, 7, 1,
     +		      1, 7, 1, 7, 1, 7, 1, 7,
     +	              7, 1, 7, 1, 7, 1, 7, 1 /

	data fpat2 /  4, 0, 0, 0, 0, 0, 0, 0,
     +		      4, 0, 0, 0, 0, 0, 0, 0,
     +		      4, 0, 0, 0, 0, 0, 0, 0,
     +		      4, 0, 0, 0, 0, 0, 0, 0,
     +		      4, 0, 0, 0, 0, 0, 0, 0,
     +		      4, 0, 0, 0, 0, 0, 0, 0,
     +		      4, 0, 0, 0, 0, 0, 0, 0,
     +	              4, 4, 4, 4, 4, 4, 4, 4 /

	data fpat3 / 12,12,12,12, 5, 5, 5, 5, 
     +		     12,12,12,12, 5, 5, 5, 5, 
     +		     12,12,12,12, 5, 5, 5, 5, 
     +		     12,12,12,12, 5, 5, 5, 5, 
     +		      5, 5, 5, 5,12,12,12,12, 
     +		      5, 5, 5, 5,12,12,12,12, 
     +		      5, 5, 5, 5,12,12,12,12, 
     +	              5, 5, 5, 5,12,12,12,12 /

	data fpat4 / 10, 0, 0, 0, 0, 0, 0, 0,
     +		     10,10, 0, 0, 0, 0, 0, 0,
     +		     10, 0,10, 0, 0, 0, 0, 0,
     +		     10, 0, 0,10, 0, 0, 0, 0,
     +		     10, 0, 0, 0,10, 0, 0, 0,
     +		     10, 0, 0, 0, 0,10, 0, 0,
     +		     10, 0, 0, 0, 0, 0,10, 0,
     +	             10, 0, 0, 0, 0, 0, 0,10 /

	data style /  1,0,1,0,1,0,1,0,
     +		      0,1,0,1,0,1,0,1,
     +		      1,0,1,0,1,0,1,0,
     +		      0,1,0,1,0,1,0,1,
     +		      1,0,1,0,1,0,1,0,
     +		      0,1,0,1,0,1,0,1,
     +		      1,0,1,0,1,0,1,0,
     +		      0,1,0,1,0,1,0,1 /


c	****************************************************************
c------ initialize matrices to identity
	do 10 j=1,3
	   do 10 k=1,3
	      do 5 i=1,3
		xyz(i,k,j)=0.
5	      continue
	      xyz(k,k,j)=1.
10	continue
c------ Search EGA ROM for raster character set.
c	This is to maintain compatibility with non IBM adapters.
c
	call FONADD( 14,1,lfont )
	if( lfont(1).eq.0 ) then
     		write(*,*) 'Error -- Can''t Find  8 x 14 Raster Font'
		pause 'Demo Text Will Appear Incorrectly'
	endif
	call FONADD(  8,0,sfont )
	if( sfont(1).eq.0 ) then
     		write(*,*) 'Error -- Can''t Find  8 x 8 Raster Font'
		pause 'Demo Text Will Appear Incorrectly'
	endif
c------ If successful, lfont and sfont hold the offset
c	and segment for the two raster fonts.
c
c------ Get profile
c
	PCAT=.true.

c	========================= Display Title ========================
c
c------ set graphics mode
	call INIT( 1 )
c------ check memory installed
	call INQMEM( imem )
	if( imem.eq.0 ) then
	  write(*,*) 'Error -- This EGA Adapter Has Only 64K'
	  write(*,*) 'This driver requires at least 128K of'
	  write(*,*) 'Graphics Memory'
	  stop 'Demo Terminated'
	elseif( imem.lt.3 ) then
	  write(*,*) 'NOTICE !!'
	  write(*,*) 'This EGA Adapter Has Less Than 256K'
	  write(*,*) 'Of Graphics Memory Installed.  Some'
	  write(*,*) 'features of this demo must be omitted.'
	  write(*,*) 'If you have access to a 256K adapter'
	  write(*,*) 'please use it for this demonstration.'
	  write(*,*) ' '
	  write(*,*) 'Thank You,   C.S.G.'
	  write(*,*) 'Press Any Key To Continue'
	  do 50 j=1,700
		call INKEY( is,ir )
		if( (is.ne.0).OR.(ir.ne.0) ) goto 51
		call VWAIT( 1 )
50	  continue
51	  mem256=.false.
	else
	  mem256=.true.
	endif
c------ save color map
	do 100 j=1,16
		call INQMAP( j-1,imap(1,j),imap(2,j),imap(3,j) )
100	continue
c------ clear color map
	do 110 j=0,15
		call COLMAP( j,0,0,0 )
110	continue
c------ draw rectangles
	ix1=0
	iy1=0
	ix2=639
	iy2=349
	idel=25
	do 1100 j=15,0,-1
c------ set drawing color
		call DCOLOR( j )
c------ draw rectangle
		idel=idel*.93
		call RECTAB( ix1,iy1,ix2,iy2,1 )
		ix1=ix1+idel
		iy1=iy1+idel/3
		ix2=ix2-idel
		iy2=iy2-idel/3
1100	continue
c	------ draw frame lines
c------ move
	call MOVEAB( 0,0 )
c------ outline title area in black
	call DCOLOR( 0 )
	call POLYAB( 7,titfram,0 )
c------ spin through colormap
	is=0
	do 1120 j=1,97
c------ load map
	ind=0	
	is=is+1
	if( is.gt.5 ) is=1
	ip=is
	   do 1110 ic=1,3
		do 1110 k=1,5
		ind=ind+1
		call COLMAP( ind,cmap(1,ip)*ic,cmap(2,ip)*ic,
     +                       cmap(3,ip)*ic )
		ip=ip+1
		if( ip.gt.5 ) ip=1
1110	   continue	
c------ use vertical retrace as delay
	call VWAIT( int(j/10) )
1120	continue
c	------------------------ Scroll Title --------------------------
	call DCOLOR( 13 )
	inc=0
	icou=0
	do 1150 j=1,110
		inc=inc+1
		if( inc.gt.14 ) inc=1
		if( (inc.eq.1).AND.(icou.lt.5 )) then
			call MOVEAB( 187,275 )
			icou=icou+1
			call TEXT( title(icou),33 )
		endif
	call CPYBLK( 184,62,184,61,272,230 )
1150	continue
c------ pause
	call VWAIT( 30 )
c	------------------------ Scroll Each Row -----------------------
	idest=0
	do 1160 ml=1,4
	idest=idest+14
	   do 1160 j=1,idest
		call VWAIT( 1 )
		call CPYBLK( 184,180,184,179,272,ml*14 )
1160	continue		
c	------------------------ Fade To Black -------------------------
	do 1170 ml=0,15
	   call VWAIT( 1 )
	   call COLMAP( ml,0,0,0 )
1170	continue
c	------------------------ Reinitialize colormap -----------------
c------ erase
	call DERASE
c------ reset
	do 1180 j=1,16
		call COLMAP( j-1,imap(1,j),imap(2,j),imap(3,j) )
1180	continue
c	============= Perform a series of fast rectangles ==============
c	Functions 2,6,12,17
1200	call DCOLOR( 15 )
	call MOVEAB( 0,0 )
	if( PCAT ) then
		call TEXT( '3000 Fast Filled Rectangles',27 )
		numrecs=3000
	else
		call TEXT( '2000 Fast Filled Rectangles',27 )
		numrecs=2000
	endif
c
	ix1=300
	iy1=150
	iwid=50
	ihi=50
	ix2=ix1+iwid
	iy2=iy1+ihi
	idx=10
	idy=10
	icol=1
	isize=5
	do 1250 ml=1,numrecs
	   icol=icol+1
	   if( icol.gt.15 ) icol=0
	   call DCOLOR( icol )
	   call RECTAB( ix1,iy1,ix2,iy2,1 )
	   if( (ix1.gt.550-iwid).or.(ix1.lt.10) ) idx=-idx
	   if( (iy1.gt.300-ihi ).or.(iy1.lt.30) ) idy=-idy
	   ix1=ix1+idx
	   iy1=iy1+idy
	   ix2=ix1+iwid
	   iy2=iy1+ihi
	   if( (iwid.gt.70).or.(iwid.lt.10) ) isize=-isize
	   iwid=iwid+isize
	   ihi=ihi+isize
1250	continue
c------ Create SINTAB, use operation as pause
	th=0.
	do 1255 j=1,36
		sintab(1,j)=cos(th)
		sintab(2,j)=sin(th)
		th=th+.1745
1255	continue
	if( PCAT ) call VWAIT( 100 )
c	====================== Draw A Doily ============================
c	Functions 2,6,7,12,17
c
c------ determine the points
1300	it=1
	do 1310 j=1,18
		circ(1,j)=int( (150.*sintab(1,it))+320 )
		circ(2,j)=int( (150.*sintab(2,it))+175 )
		it=it+2
1310	continue
c------ clear screen
	call DERASE
c------ draw background mat
	call MOVEAB( 100,0 )
	call DCOLOR( 1 )
	call RECTAB( 100,0,539,349,1 )
c------ label operation
	call PATBCL( -1 )
	call DCOLOR( 15 )
	call TEXT( 'High Speed Vectors',18 ) 
	call DCOLOR( 4 )
	call RECTAB( 170,25,470,325,1 )
c------ draw vectors
	call DCOLOR( 15 )
	do 1320 ml=1,18,2
	   ist=ml
	   call MOVEAB( circ(1,ml),circ(2,ml) )
	   do 1320 j=1,18
		ist=ist+1
		if( ist.gt.18 ) ist=1
		call DRAWAB( circ(1,ist),circ(2,ist) )
1320	continue
c------ xored object
c------ set logic to xor
	call DRWLOG( 3 )
	call DCOLOR( 15 )
	ix=300
	iy=150
	idx=10
	idy=10
	new=.true.
	str='Easily Move Any Xor''ed Object'
	if( PCAT ) then
		num=250
	else
		num=150
	endif
c
	do 1350 ml=1,num
	   if( (ix.gt.395).or.(ix.lt.1) ) idx=-idx
	   if( (iy.gt.324).or.(iy.lt.1) ) idy=-idy
	   ix=ix+idx
	   iy=iy+idy
	   call VWAIT( 1 )
	   if( new ) then
		new=.false.
	   else
		call MOVEAB( ixo,iyo )
		call TEXT( str,29 )
	   endif
	   call MOVEAB( ix,iy )
	   ixo=ix
	   iyo=iy
	   call TEXT( str,29 )
1350	continue
c------ set logic to replace
	call DRWLOG( 0 )
	if( PCAT ) then
		call VWAIT( 300 )
	else
		call VWAIT( 100 )
	endif
c	================== Demo Fill Patterns ==========================
c	Functions 6,8,9,11,14,15,17,27
c------ DERASE display
1400	call DERASE
	call DCOLOR( 4 )
	call MOVEAB( 0,349 )
	it=1
	do 1410 j=1,36,2
		pt(j)=(j-1)*15
		pt(j+1)=(30*sintab(2,it))+100
		it=it+4
		if( it.gt.36 ) it=it-36
		pt(j+36)=639-pt(j)
		pt(j+37)=pt(j+1)+75
		pt(j+72)=pt(j)
		pt(j+73)=pt(j+37)+75
1410	continue
	pt(109)=pt(37)
	pt(110)=pt(38)
	pt(111)=639
	pt(112)=349
	pt(113)=0
	pt(114)=349
	call POLYAB( 57,pt,0 )
c------ put a border on the screen
	call RECTAB( 0,0,639,349,0 )
c	---------------------- Perform Floods -------------------
	do 1430 im=1,2
c------ Flood #1
	if( im.eq.2 ) then
		call FLSTYL( fpat1 )
	else
		call DCOLOR( 8+im )
	endif
	call FLOOD( 500,10 )
c------ Flood #3
	if( im.eq.2 ) then
		call FLSTYL( fpat3 )
	else
		call DCOLOR( 1+im )
	endif
	call FLOOD( 10,175 )
c------ Flood #2
	if( im.eq.2 ) then
		call FLSTYL( fpat2 )
	else
		call DCOLOR( 4+im )
	endif
	call FLOOD( 100,250 )
c------ Flood #4
	if( im.eq.2 ) then
		call FLSTYL( fpat4 )
	else
		call DCOLOR( 0+im )
	endif
	call FLOOD( 10,330 )
c------ label solids
	if( im.eq.1 ) then
		call PATBCL( -1 )
		call MOVEAB( 10,10 )
		call DCOLOR( 15 )
		call TEXT('You Can Perform Solid Floods, Or....',36) 
		call VWAIT( 150 )
	endif
1430	continue
c------ Label region
	call PATBCL( -1 )
	call DCOLOR( 15 )
	call MOVEAB( 10,24 )
	call TEXT('You can create any line style',29) 
	call MOVEAB( 10,38 )
	call TEXT('or fill style.',14) 
c------ show overlayed pattern
	call FLSTYL( fpat4 )
	call DCOLOR( 0 )
	call RECTAB( 220,100,320,250,1 )
	call DCOLOR( 15 )
	call MOVEAB( 220,66 )
	call TEXT( 'Patterns Can',12 )
	call MOVEAB( 220,80 )
	call TEXT( 'Be Transparent',14 ) 
c------ show pattern with background
	call PATBCL( 4 )
	call DCOLOR( 15 )
	call RECTAB( 350,100,450,250,1 )
	call MOVEAB( 350,66 )
	call TEXT( 'Or Patterns Can Have',20 )
	call MOVEAB( 350,80 )
	call TEXT( 'A Background color',18 )
	if( PCAT ) then
		call VWAIT( 400 )
	else
		call VWAIT( 300 )
	endif
c	===================== Dither Some DCOLORs =======================
c------ clear the screen
1500	call DERASE
	irow=0

	do 1550 c1=0,15
	row   = row+20
	start = 0

	do 1540 c2=0,c1

	call DCOLOR( c2 )

c------ Generate a pattern set
		do 1530 j=1,64
		    if( ichar( style(j) ).EQ.1 ) then
			fstyle(j)=char( c1 )
		    else
			fstyle(j)=char( c2 )
		    endif
1530		continue
c------ Draw
		call FLSTYL( fstyle )
		call RECTAB( start, row, start+34, row+19, 1 )

		start = start + 35
1540	continue
1550	continue
	call FLSTYL( solid )		
c------ set color
	call PATBCL( 0 )
	call DCOLOR( 2 )
c------ output text
	call MOVEAB( 175,10 )
	call TEXT(
     +	'You Can Display Thousands Of Unique Colors At One Time',54)
	call MOVEAB( 175,24 )
	call DCOLOR( 15 )
	call TEXT('       By Using Fill Patterns And Mixing Colors',47)
	call VWAIT( 200 )
c	======================= Draw Some Laser Text ===================
c------ Line 1
	call MOVEAB( 5,70 )
	call DCOLOR( 14 )
	call LDFONT( 'fnt1.sfp',buff )
	call DERASE
	call TEXT( 'Laser Soft Fonts',16 )
c------ Line 2
	call MOVEAB( 185,100 )
	call DCOLOR( 10 )
	call LDFONT( 'fnt2.sfp',buff )
	call TEXT( 'Are Ideal For',13 )
c------ Line 3
	call MOVEAB( 35,175 )
	call DCOLOR( 9 )
	call LDFONT( 'fnt3.sfp',buff )
	call TEXT( 'Presentation Graphics',21 )
c------ Line 4
	call MOVEAB( 40,250 )
	call DCOLOR( 12 )
	call LDFONT( 'fnt4.sfp',buff )
	call TEXT( 'You can use any SoftFont that is',32 )
	call MOVEAB( 20,280 )
	call TEXT( 'formatted for the HP LaserJet Plus.',35 )
	call MOVEAB( 20,310 )
	call TEXT( 'Choose from hundreds of styles and',34 )
	call MOVEAB( 20,340 )
	call TEXT( 'sizes!',6 )
c------ Reset text to normal
	call DFNFNT( lfont,14,0 )
c	======================= Rotate Box =============================
c	Functions 2,4,5,6,9,11,17
c	This section uses bit planes on the same page to
c	perform double buffering.
	call INROT( xyz )
c====== pre rotate cube
c---------- X-Y
	do 1640 j=1,2
c-------------- 30 degree rotation
	  do 1640 k=1,3
	   do 1640 i=1,15
		call M3X1( xyz(1,1,j),cube(1,i),r1 )
	      do 1640 n=1,3
		cube(n,i)=r1(n)
1640	continue
c====== Create data point array
	iptr=1
	sc=1
	rate=.9
	do 1650 is=1,2
		if( is.eq.2 ) rate=-rate
	do 1650 ml=1,4
c---------- X-Y-Z
	    do 1650 j=1,3
c-------------- 90 degree rotation
		do 1650 k=1,9
		   sc=sc+rate
		   do 1650 i=1,15
			call M3X1( xyz(1,1,j),cube(1,i),r1 )
			buff(iptr)=(sc*r1(1))+250
			buff(iptr+1)=(sc*r1(2))+175
			iptr=iptr+2
		      do 1650 n=1,3
			cube(n,i)=r1(n)
1650	continue
c====== setup DCOLORmap
	call DERASE
	call COLMAP(  1,0,0,2 )
	call COLMAP(  4,0,0,2 )
	call COLMAP(  2,3,0,0 )
	call COLMAP(  8,3,0,0 )
	call COLMAP(  3,3,3,3 )
	call COLMAP( 12,3,3,3 )
c====== label and outline
	call WRMASK( 3 )
	call RDMASK( 12 )
	call PATBCL( -1 )
	do 1660 j=1,2
c------ out
		if( j.eq.1 ) call DCOLOR( 1 )
		if( j.eq.2 ) call DCOLOR( 4 )
		call RECTAB( 99,49,401,301,0 )
c------ label
		call DCOLOR( 15 )
		call MOVEAB( 410,100 )
		call TEXT( 'Double Buffering Allows',23 )
		call MOVEAB( 410,114 )
		call TEXT( 'Smooth Animation',16 )
		call WRMASK( 12 )
		call RDMASK( 3 )
1660	continue		
c====== Animate
	iptr=1
	pzero=.true.
	do 1700 ml=1,216
		call VWAIT( 1 )
c------ set pages
		if( pzero ) then
			pzero=.false.
			call WRMASK( 3 )
			call RDMASK( 12 )
			icol=2
		else
			pzero=.true.
			call WRMASK( 12 )
			call RDMASK( 3 )
			icol=8
		endif
c------- clear area
		call DCOLOR( 0 )
		call RECTAB( 100,50,400,300,1 )
		call DCOLOR( icol )
c------- draw
		call MOVEAB( buff(iptr+6),buff(iptr+7) )
		call POLYAB( 15,buff(iptr),0 )
c------- update
		iptr=iptr+30
1700	continue
	call WRMASK( 15 )
	call DERASE
	call RDMASK( 15 )
c~	==================== Multiple Plane Plots ======================
c------ set some DCOLOR registers
2000	call COLMAP( 1,2,2,3 )
	call COLMAP( 2,0,3,0 )
	call COLMAP( 4,3,0,0 )
	call COLMAP( 8,2,2,2 )
c------ draw with all bits on
	call DCOLOR( 15 )
c------ frame the screen
	call RECTAB( 0,0,639,349,0 )
c	--------------------- Draw Four Functions ----------------------
c------ plane 0
c------ set R/W masks
	call RDMASK( 1 )
	call WRMASK( 1 )
	it=1
	ix=0
	do 2100 j=1,130,2
		pt(j)=ix
		pt(j+1)=100*sintab(2,it)+175
		ix=ix+10
		it=it+1
		if( it.gt.36 ) it=1
2100	continue
	call MOVEAB( pt(1),pt(2) )
	call POLYAB( 65,pt,0 )
c------ label
	call MOVEAB( 100,10 )
	call TEXT( 'PLANE 0',7 )
c------ delay
	call VWAIT( 50 )
c====== plane 1
c------ set R/W masks
	call RDMASK( 2 )
	call WRMASK( 2 )
	it=1
	ix=0
	do 2110 j=1,130,2
		pt(j)=ix
		pt(j+1)=100*sintab(1,it)+175
		ix=ix+10
		it=it+1
		if( it.gt.36 ) it=1
2110	continue
	call MOVEAB( pt(1),pt(2) )
	call POLYAB( 65,pt,0 )
c------ label
	call MOVEAB( 200,10 )
	call TEXT( 'PLANE 1',7 )
c------ delay
	call VWAIT( 50 )
c====== plane 2
c------ set R/W masks
	call RDMASK( 4 )
	call WRMASK( 4 )
	it=1
	ix=0
	freq=170
	do 2120 j=1,642,2
		pt(j)=ix
		pt(j+1)=(freq*sintab(2,it))+175
		ix=ix+2
		it=it+1
		if( it.gt.36 ) it=1
		freq=freq-.5
2120	continue
	call MOVEAB( pt(1),pt(2) )
	call POLYAB( 320,pt,0 )
c------ label
	call MOVEAB( 300,10 )
	call TEXT( 'PLANE 2',7 )
c------ delay
	call VWAIT( 50 )
c====== plane 3
c------ set R/W masks
	call RDMASK( 8 )
	call WRMASK( 8 )
	ix=0
	i=100
	flip=.false.
	do 2130 j=1,66,2
		pt(j)=ix
		pt(j+1)=i+175
		if( flip ) then
			i=-i
			flip=.false.
		else
			flip=.true.
		endif
		ix=ix+20
2130	continue
	call MOVEAB( pt(1),pt(2) )
	call POLYAB( 33,pt,0 )
c------ label
	call MOVEAB( 400,10 )
	call TEXT( 'PLANE 3',7 )
c------ delay
	call VWAIT( 50 )
c------
c------ set R/W masks
	do 2140 j=1,15
	  call RDMASK( j )
	  call WRMASK( j )
	  call VWAIT( 50 )
2140	continue
	call DERASE
c------ reset DCOLOR map
	do 2200 j=1,16
		call COLMAP( j-1,imap(1,j),imap(2,j),imap(3,j) )
2200	continue
c	==================== Shaded Balls ==============================
c------ set clipping region
3000	call DCOLOR( 4 )
	call RECTAB( 0,0,639,349,0 )
	call OCLIP( 0,0,639,349 )
	iy1=10
	irad=0
	do 3500 ml=1,6
		irad=irad+5
		call GENSPH( irad,buff )
		ix1=70
		iy1=iy1+50
		do 3500 j=1,7
		  call DRWSPH( ix1,iy1,irad,bcols(1,j),buff )
		  ix1=ix1+80
3500	continue			
c------ label
	call DCOLOR( 15 )
	call MOVEAB( 10,5 )
	call TEXT( 'Generate High Speed Shaded Balls On The Fly',43 )	
	call VWAIT( 300 )
c	---------------------- Show Clipping Example -------------------
c------ set clipping region
	call OCLIP( 120,50,500,300 )
c------ setup on both pages
	do 3555 j=0,1
c------ set pages
	call RWPAGE( 0,j )
	call DERASE
	call DCOLOR( 12 )
	call RECTAB( 120,50,500,300,0 )
c------ label
	call DCOLOR( 15 )
	call MOVEAB( 107,20 )
	call TEXT(
     +  'The Balls Are Always Clipped To A User Defined Region',53 )
	call MOVEAB( 195,305 )
	call TEXT( 'They Are Excellent For Modeling',31 )
	call MOVEAB( 154,319 )
	call TEXT('Particle Dynamics And Molecular Structures',42)
	if( .not.mem256 ) goto 3556
3555	continue
c------ note memsize
3556	if( .not.mem256 ) then
	  call MOVEAB( 0,0 )
	  call DCOLOR( 15 )
	  call TEXT( 
     +    'Note: Insufficient Graphics Memory For Double Buffering',55)
	endif
c------ bounce a ball
	call DCOLOR( 0 )
	irad=25
	call GENSPH( irad,buff )
c------ set positions
	do 3560 j=1,5
		ipb(1,j)=350
		ipb(2,j)=200
3560	continue
c	-------------------------- Animate
	if( PCAT ) then
		ireps=250
	else
		ireps=80
	endif
	ipage=0
	do 3600 j=1,ireps
	if( mem256 ) then
		ipage=abs(ipage-1)
		call RWPAGE( 0,ipage )
	endif
c------ DERASE
	call RECTAB( 121,51,499,299,1 )
	  do 3590 k=1,5
	  if( (ipb(1,k).lt.120).or.(ipb(1,k).gt.500) ) then
		idb(1,k)=-idb(1,k)
	  endif
	  if( (ipb(2,k).lt.50).or.(ipb(2,k).gt.300) )  then
		idb(2,k)=-idb(2,k)
	  endif
	  ipb(1,k)=ipb(1,k)+idb(1,k)
	  ipb(2,k)=ipb(2,k)+idb(2,k)
c----- draw new
	call DRWSPH( ipb(1,k),ipb(2,k),irad,bcols(1,k),buff )
3590	continue
c------ set pages
	if( mem256 ) call VPAGE( ipage )
3600	continue
	if( PCAT ) call VWAIT( 50 )
c	===================== Use Same Screen For Benzene ==============
c------ pick small text
	call DFNFNT( sfont,8,0 )
c------ generate H ball
	call GENSPH( 14,hbuff )
c------ create position points
	do 3650 j=1,36
		circ(1,j)=48*sintab(1,j)+320
		circ(2,j)=48*sintab(2,j)+175
		circ2(1,j)=86*sintab(1,j)+320
		circ2(2,j)=86*sintab(2,j)+175
		circh(1,j)=115*sintab(1,j)+320
		circh(2,j)=113*sintab(2,j)+175
3650	continue
c====== 
	is=0
	ipage=0
c------ set text to overlay
	call VPAGE( ipage )
	call PATBCL( -1 )
	if( PCAT ) then
		ireps=60
	else
		ireps=30
	endif
c
	do 3700 ml=1,ireps
	if( mem256 ) then
		ipage=abs(ipage-1)
		call RWPAGE( 0,ipage )
	endif
c------ DERASE
	call DCOLOR( 0 )
	call RECTAB( 121,51,499,299,1 )
c------ draw the balls
	is=is+1
	if( is.gt.36 ) is=1
	ip=is
	ia=1
	   do 3675 k=1,6
c------ Carbon
		call DRWSPH( circ(1,ip),circ(2,ip),irad,
     +                       bcols(1,1),buff )
c------ label C
c------ set white for text
		call DCOLOR( 15 )
		call MOVEAB( circ(1,ip)-8,circ(2,ip)-4 )
		call TEXT( atm(ia),2 )
c------ Hydrogen
		call DRWSPH( circ2(1,ip),circ2(2,ip),14,
     +                       bcols(1,6),hbuff )
c------ label H
		call MOVEAB( circh(1,ip)-8,circh(2,ip)-4 )
		call TEXT( atm(ia+1),2 )
c------ update pointer
		ip=ip+6
		if( ip.gt.36 ) ip=ip-36
		ia=ia+2
3675	   continue
c------ label molecule
	call MOVEAB( 130,60 )
	call TEXT( 'BENZENE',7 )
	if( mem256 ) call VPAGE( ipage )
3700	continue
c------ pick large text
	call DFNFNT( lfont,14,0 )
c	==================== Over Sized Display ========================
4000	if( .not.mem256 ) then
	    call DERASE
	    call COLMAP( 7,3,3,3 )
	    write(*,*) 'Insufficient Graphics Memory To Complete Demo'
	    call VWAIT( 200 )
	    goto 6000
	endif
c------ get data
	Inquire( file='slice.data',exist=exi )
	if( .not.exi ) then
		write(*,*) 'Error -- File SLICE.DAT Not Found'
		call VWAIT( 200 )
		goto 6000
	endif
	Open(1,file='slice.dat',status='old',form='binary')
	read(1) buff
	Close(1)
c------ set all memory to write enabled
	call RWPAGE( 0,2 )
c------ DERASE
	call DERASE
	call VPAGE( 0 )
c------ set patterns to no overlay
	call PATBCL( 0 )
c------ set width to 800 pixels (i.e. 50 words)
	call SWIDTH( 50 )
c------ set the DCOLOR map
	do 4010 j=1,10
		call COLMAP(j-1,imcols(1,j),imcols(2,j),imcols(3,j))
4010	continue
c------ frame
	call DCOLOR( 15 )
	call RECTAB( 0,0,799,599,0 )
c	----------------------- Place The Image ------------------------
	call MOVEAB( 240,120 )
	call WRBBLK( 320,360,buff )
c------ draw the legend
	iy1=130
	iy2=150
	do 4500 j=9,0,-1
		call DCOLOR( j )
		call RECTAB( 100,iy1,150,iy2,1 )
		iy1=iy1+20
		iy2=iy2+20
4500	continue
c	------------------------ LABEL ---------------------------------
	call DCOLOR( 15 )
c------ label horizontal resolution
	call MOVEAB( 1,11 )
	call TEXT( char(27),1 )
	call MOVEAB( 790,11 )
	call TEXT( char(26),1 )
	call MOVEAB( 1,17 )
	call DRAWAB( 799,17 )
	call MOVEAB( 332,11 )
	call TEXT( ' 800 Pixels Wide ',17 )
c------ draw on bottom also
	call MOVEAB( 1,574 )
	call TEXT( char(27),1 )
	call MOVEAB( 790,574 )
	call TEXT( char(26),1 )
	call MOVEAB( 0,580 )
	call DRAWAB( 799,580 )
	call MOVEAB( 332,574 )
	call TEXT( ' 800 Pixels Wide ',17 )
c
c------ vertical resolution
	call MOVEAB( 11,1 )
	call TEXT( char(24),1 )
	call MOVEAB( 11,585 )
	call TEXT( char(25),1 )
	call MOVEAB( 15,1 )
	call DRAWAB( 15,600 )
	cv=' 600 Pixels High '
	do 4510 j=1,17
		call MOVEAB( 11,244+((j-1)*14) )
		call TEXT( cv(j:j),1 )
4510	continue
c------ legend
	call MOVEAB( 88,100 )
	call TEXT( 'Intensity',9 )
	call MOVEAB( 88,114 )
	call TEXT( '  Scale',7 )
c------ eyes
	call MOVEAB( 390,100 )
	call TEXT( 'Eyes',4 )
	call MOVEAB( 385,107 )
	call DRAWAB( 335,127 )
	call MOVEAB( 427,107 )
	call DRAWAB( 477,127 )
c------ Ears
	call MOVEAB( 160,340 )
	call TEXT( 'Left Ear',8 )
	call MOVEAB( 575,340 )
	call TEXT( 'Right Ear',9 )
c------ main label
	call MOVEAB( 490,100 )
	call TEXT( 'Magnetic Resonance Image',24 )
	call MOVEAB( 490,114 )
	call TEXT( 'Of A Coronal Section',20 )
	call VWAIT( 40 )
c
c------ pan through display
	ix=0
	iy=0
	do 4600 i=0,160	
		call PAN( ix,iy )
		ix=ix+1
		call VWAIT( 1 )
4600	continue
	call VWAIT( 60 )
	do 4610 i=0,250	
		call PAN( ix,iy )
		iy=iy+1
		call VWAIT( 1 )
4610	continue
	call VWAIT( 60 )
	do 4620 i=0,160
		ix=ix-1
		call PAN( ix,iy )
		call VWAIT( 1 )
4620	continue
	call VWAIT( 60 )
	do 4630 i=0,250	
		iy=iy-1
		call PAN( ix,iy )
		call VWAIT( 1 )
4630	continue
	call VWAIT( 60 )
	do 4640 i=0,100	
		ix=ix+1
		iy=iy+1
		call PAN( int(ix/1.5),iy )
		call VWAIT( 1 )
4640	continue
	call VWAIT( 400 )
	call DERASE
c	===================== Split Screen ==============================
c------ reset pan
5000	call PAN( 0,0 )
c------ set width to 640 pixels (i.e. 40 words)
	call SWIDTH( 40 )
c------ set to write enabled page 1
	call RWPAGE( 1,1 )
c------ set visual page to 1
	call VPAGE( 1 )
c------ frame
	call DCOLOR( 15 )
	call RECTAB( 0,0,639,400,0 )
c------ Label
	call MOVEAB( 5,5 )
	call TEXT( 'This Is Screen B',16 )
c------ write block
	call MOVEAB( 160,1 )
	call WRBBLK( 320,360,buff )
c------ draw the legend
	iy=30
	do 5100 j=9,0,-1
		call DCOLOR( j )
		call RECTAB( 50,iy,100,iy+20,1 )
		iy=iy+20
5100	continue
c	----------------------------------------------------------------
	do 5300 ip=1,2
c------ set to write enabled page 0
	call RWPAGE( 0,0 )
	ispx=349
	exi=.true.
	flip=.true.
	call DCOLOR( 15 )
	call MOVEAB( 0,0 )
	call TEXT( 'This Is Screen A',16 )
c
	ix1=300
	iy1=150
	iwid=50
	ihi=50
	ix2=ix1+iwid
	iy2=iy1+ihi
	idx=10
	idy=10
	icol=1
	isize=5
	do 5300 ml=1,2800
	   icol=icol+1
	   if( icol.gt.15 ) icol=0
	   call DCOLOR( icol )
	   call RECTAB( ix1,iy1,ix2,iy2,1 )
	   if( (ix1.gt.550-iwid).or.(ix1.lt.10) ) idx=-idx
	   if( (iy1.gt.300-ihi ).or.(iy1.lt.30) ) idy=-idy
	   ix1=ix1+idx
	   iy1=iy1+idy
	   ix2=ix1+iwid
	   iy2=iy1+ihi
	   if( (iwid.gt.70).or.(iwid.lt.10) ) isize=-isize
	   iwid=iwid+isize
	   ihi=ihi+isize
c------ pull up screen 0
	if( flip ) then
		if( exi ) then
			call SPLIT( ispx )
			ispx=ispx-1
		else
			if( ispx.gt.349 ) goto 5300
			call SPLIT( ispx )
			ispx=ispx+1
		endif
		flip=.false.
	endif
	if( mod(ml,4).eq.0 ) flip=.true.
c------
	if( ml.gt.1390 ) exi=.false.	
5300	continue
c------ pause
	call VWAIT( 300 )
c------ reset
	call RWPAGE( 0,1 )
	call DERASE
	do 5480 j=1,16
		call COLMAP( j-1,imap(1,j),imap(2,j),imap(3,j) )
5480	continue
c	================================================================
c------ reset text mode
6000	call FINIT
c------ make text white
	call COLMAP( 7,3,3,3 )
	write(*,*) '              Modes Supported'
	write(*,*) '                                 Monitor Type'
	write(*,*) ' 640w x 350h x 16c x 2pgs           EGA'
	write(*,*) ' 512w x 430h x 16c x 2pgs         Switching'
	write(*,*) ' 512w x 511h x 16c x 2pgs         Switching'
	write(*,*) ' 640w x 200h x 16c x 4pgs         Std. CGA'
	write(*,*) ' 640w x 480h x 16c x 1pg          Switching'
	write(*,*) ' 640w x 480h x 16c x 1pg            VGA'
	write(*,*) ' 752w x 410h x 16c x 1pg          Switching'
	write(*,*) ' 800w x 600h x 16c x 1pg          Switching'
	write(*,*) ' '
	write(*,*) '              Languages'
	write(*,*) ' '
	write(*,*) ' Microsoft            FORTRAN, C, QC, QBASIC, PASCAL'
	write(*,*) ' Ryan McFarland(IBM)  Professional FORTRAN'
	write(*,*) ' Borland              Turbo C, Turbo Pascal'
	write(*,*) ' '
	write(*,*) ' All source code is provided !'
	write(*,*) ' Plus complete examples for all languages, over 200'
	write(*,*) ' example programs in all.'
	write(*,*) ' '
	write(*,*) ' CONNELL SCIENTIFIC GRAPHICS   (206) 485-2828'
	write(*,*) ' PO Box 1765, Woodinville, WA  98072-1765'
	write(*,*) ' USA'
c
c------ hold the display
	write(*,*) 'Press Any Key To Continue'
	do 6050 j=1,700
		call INKEY( is,ir )
		if( (is.ne.0).OR.(ir.ne.0) ) goto 6051
		call VWAIT( 1 )
6050	continue
c------ reset to gray
6051	call COLMAP( 7,2,2,2 )
	end
c
c	****************************************************************
c
	SUBROUTINE M3X1( m3,v1,r1 )
c	This routine multiplies the vector v1 by the
c	matrix m3 and yields the result r1.
c	--------------------------------------------
	real m3(3,3),v1(3),r1(3)
c	--------------------------------------------
	do 10 j=1,3
		r1(j)=0.
		do 10 k=1,3
		   r1(j)=r1(j)+(v1(k)*m3(j,k))
10	continue
	return
	end
c
c	****************************************************************
c
	SUBROUTINE INROT( xyz )
c	This routine evaluates the 3 rotation
c	matrices fixed at 10 degree increments.
c	--------------------------------------
	common /idat2/ hbuff,pt,sintab
	integer*2 hbuff(600),pt(1000)
	real xyz(3,3,3),sintab(2,36)
c	--------------------------------------
c------ xmat
	xyz(2,2,1)=sintab(1,2)
	xyz(2,3,1)=-sintab(2,2)
	xyz(3,2,1)=sintab(2,2)
	xyz(3,3,1)=sintab(1,2)
c------ ymat
	xyz(1,1,2)=sintab(1,2)
	xyz(1,3,2)=sintab(2,2)
	xyz(3,1,2)=-sintab(2,2)
	xyz(3,3,2)=sintab(1,2)
c------ zmat
	xyz(1,1,3)=sintab(1,2)
	xyz(1,2,3)=-sintab(2,2)
	xyz(2,1,3)=sintab(2,2)
	xyz(2,2,3)=sintab(1,2)
	return
	end

